<?php
require_once('./Config/Config.php');
require_once('./Config/Autoload.php');
$partie_gateway= new PartieGateway();
Autoload::charger();

// pas d'arrêt d'éxécution du script (No timeout)

set_time_limit(0);

// Créer une socket d'écoute

$socket = socket_create(AF_INET, SOCK_STREAM,0) or die("la socket n'a pas pu être crée\n");

// Attacher la socket à unde adresse ip et un port

$result = socket_bind($socket,$serverAdress,$port) or die("la socket n'a pas pu être attachée au serveur à l'adresse ");

// tableau de groupe de sockets avec comme paire clés valeurs
// l'identifiant de la partie et l'ensemble de connections

$arraySocketGroup=array();

// tableau des connections en attente de pouvoir créer une partie

$socketsFromQueue=array();

// tableau des sockets à surveiller en lecture

$read=array($socket);

// tableau des sockets à surveiller en écriture

$write=array();

//tableau des sockets à surveiller parce qu'elles ont des erreurs

$except=array();

// reponse du serveur au client

$response='';

// requête du client au serveur

$request='';

while(true) {

  // Commencer à écouter sur le port
  $result = socket_listen($socket) or die ("N'a pas pu configurer l'écoute sur la socket\n");

  // tant qu'il n'y a pas de connection entrante ou de requete du client bloqué le while
  socket_select($read,$write,$except,null);
  // Accepter les connections entrantes s'il y en a à cet instant t ou bloque le while tant qu'il n'y en a pas
  $client = socket_accept($socket) or die("N'a pas pu accepter les connections entrantes\n");
  
  // Ajoute la connection à un tableau de connection des joueurs en attente

  $socketsFromQueue[]=$client;

  // si le nombre de joueur par partie nécessaire est égal au nombre de connection encore dans la file d'attente 
  // alors envoie à l'utilisateur de lancer la partie et ajoute l'ensemble de connection à un tableau de groupe de sockets avec comme paire clés valeurs
  // l'identifiant de la partie et l'ensemble de connections sinon envoie à tout les utilisateurs en file d'attente qu'il faut rafraichir la page

  if(strcmp($request,"Queuing")==0)
  {
    if(count($socketsFromQueue)==$playerNumberPerGame)
    {
      $response="launchGame";
      $idPartie=$partie_gateway->findPartieInQueue();
      $arraySocketGroup[$idPartie]= $socketsFromQueue;
      $socketsFromQueue=array();
    }
    else{
      $response="refreshQueue";
    }
    foreach($socketsFromQueue as $sock)
      {
        socket_write($sock,$response,strlen($response)) or die("N'a pas pu écrire à la socket\n");
      }
  }

  // Lire le message provenant de la socket du client

  $input = socket_read($spawn,1024) or die("N'a pas pu lire de requête");
}
